<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: init/serinit.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_f813120d4be15aaed9e35a3518d2a85e.html">init</a>
  </div>
</div>
<div class="contents">
<h1>serinit.c</h1><a href="serinit_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: serinit.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="init_8h.html">init.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="magpario_8h.html">io/magpario.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#include &quot;addons/addons.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#endif</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span>
<a name="l00034"></a><a class="code" href="serinit_8c.html#ae4c8f3120a177cfe3ce6929927865a94">00034</a> <span class="keywordtype">int</span> <a class="code" href="init_8h.html#ae4c8f3120a177cfe3ce6929927865a94">SerInit</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   <span class="keywordtype">int</span> rank,size;
<a name="l00039"></a>00039   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00040"></a>00040   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   <span class="comment">/* print useful information about magpar itself, library versions, etc. */</span>
<a name="l00043"></a>00043   ierr = <a class="code" href="init_8h.html#a25ee3bfa58a704838a8bc6309f083f5c">InitInfo</a>();CHKERRQ(ierr);
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00046"></a>00046     <span class="stringliteral">&quot;--------------------------------------------------------------------------\n&quot;</span>
<a name="l00047"></a>00047     <span class="stringliteral">&quot;Starting single processor part\n&quot;</span>
<a name="l00048"></a>00048   );
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   <span class="comment">/* read FE mesh */</span>
<a name="l00051"></a>00051   ierr = <a class="code" href="magpario_8h.html#a365fc802eafb717ba4c584655d1e9b64">ReadMesh</a>(gdata);CHKERRQ(ierr);
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="comment">/* read material properties */</span>
<a name="l00054"></a>00054   ierr = <a class="code" href="magpario_8h.html#a59544353738dfce0bdce48409d9b3c8b">ReadKrn</a>(gdata);CHKERRQ(ierr);
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <span class="comment">/* modify material properties */</span>
<a name="l00057"></a>00057   ierr = <a class="code" href="init_8h.html#a155bbdd0e9cc1c9194b91b08ca8162ac">ModifyPropSer</a>(gdata);CHKERRQ(ierr);
<a name="l00058"></a>00058 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00059"></a>00059 <span class="preprocessor"></span>  ierr = ModifyPropSerGrains(gdata);CHKERRQ(ierr);
<a name="l00060"></a>00060 <span class="preprocessor">#endif</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span>
<a name="l00062"></a>00062   <span class="comment">/* initialize magnetization etc. */</span>
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00065"></a>00065 <span class="preprocessor"></span>  <span class="comment">/* FIXME: MagInit calls VertProp, which checks vertcouple</span>
<a name="l00066"></a>00066 <span class="comment">   * need to initialize before call to MagInit to avoid segv</span>
<a name="l00067"></a>00067 <span class="comment">   * better initialize all global variables (gdata struct) elsewhere! */</span>
<a name="l00068"></a>00068   gdata-&gt;vertcoupl=PETSC_NULL;
<a name="l00069"></a>00069 <span class="preprocessor">#endif</span>
<a name="l00070"></a>00070 <span class="preprocessor"></span>
<a name="l00071"></a>00071   <span class="comment">/* we need to initialize the magnetization before we modify the mesh</span>
<a name="l00072"></a>00072 <span class="comment">     (i.e. filter elements and possibly remove elements and nodes)</span>
<a name="l00073"></a>00073 <span class="comment">     in case we read the magnetization from an inp file</span>
<a name="l00074"></a>00074 <span class="comment">  */</span>
<a name="l00075"></a>00075   ierr = <a class="code" href="init_8h.html#accaf6541cd8225c7be69bdf5f6ac44d5">MagInit</a>(gdata);CHKERRQ(ierr);
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span>  ierr = Hext_in1_Init(gdata);CHKERRQ(ierr);
<a name="l00079"></a>00079   ierr = Hext_in2_Init(gdata);CHKERRQ(ierr);
<a name="l00080"></a>00080   ierr = <a class="code" href="filterelements_8c.html#a49c370a78a03718555d9d871ef6e11ee">FilterElements</a>(&amp;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,&amp;gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,&amp;gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>,gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>);CHKERRQ(ierr);
<a name="l00081"></a>00081   ierr = MeshMirror(&amp;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,&amp;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,&amp;gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>,&amp;gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,&amp;gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>);CHKERRQ(ierr);
<a name="l00082"></a>00082   ierr = <a class="code" href="filternodes_8c.html#ab1da8fc65b9539386e71fb8601e36deb">FilterNodes</a>(&amp;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,&amp;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,&amp;gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>,gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,&amp;gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;gdata-&gt;VH1,&amp;gdata-&gt;VH2);CHKERRQ(ierr);
<a name="l00083"></a>00083   <span class="keywordflow">if</span> (!rank) {
<a name="l00084"></a>00084     gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>=gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>;
<a name="l00085"></a>00085     gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a> =gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>;
<a name="l00086"></a>00086   }
<a name="l00087"></a>00087 <span class="preprocessor">#else</span>
<a name="l00088"></a>00088 <span class="preprocessor"></span>  Vec dum=PETSC_NULL;
<a name="l00089"></a>00089   ierr = <a class="code" href="filterelements_8c.html#a49c370a78a03718555d9d871ef6e11ee">FilterElements</a>(&amp;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,&amp;gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,&amp;gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>,gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>);CHKERRQ(ierr);
<a name="l00090"></a>00090   ierr = <a class="code" href="filternodes_8c.html#ab1da8fc65b9539386e71fb8601e36deb">FilterNodes</a>(&amp;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,&amp;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,&amp;gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>,gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,&amp;gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;dum,&amp;dum);CHKERRQ(ierr);
<a name="l00091"></a>00091   <span class="keywordflow">if</span> (!rank) {
<a name="l00092"></a>00092     gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>=gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>;
<a name="l00093"></a>00093     gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a> =gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>;
<a name="l00094"></a>00094   }
<a name="l00095"></a>00095 <span class="preprocessor">#endif</span>
<a name="l00096"></a>00096 <span class="preprocessor"></span>
<a name="l00097"></a>00097   <span class="comment">/* mesh refinement */</span>
<a name="l00098"></a>00098   ierr = <a class="code" href="init_8h.html#a445ec9c1079f67af589544afbcea155f">RegularRefinement</a>(gdata);CHKERRQ(ierr);
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00101"></a>00101 <span class="preprocessor"></span>  <span class="comment">/* need to do after refinement due to coupling matrix */</span>
<a name="l00102"></a>00102   ierr = DecoupleGrains(gdata);CHKERRQ(ierr);
<a name="l00103"></a>00103   <span class="comment">/* TODO: cannot move behind Reorder (and avoid renumbering coupling array) because</span>
<a name="l00104"></a>00104 <span class="comment">     Reorder generates the gdata-&gt;vertl2g, elel2g arrays</span>
<a name="l00105"></a>00105 <span class="comment">     should be done separately, so that Reorder really only renumbers vertices and elements</span>
<a name="l00106"></a>00106 <span class="comment">  */</span>
<a name="l00107"></a>00107 <span class="preprocessor">#endif</span>
<a name="l00108"></a>00108 <span class="preprocessor"></span>
<a name="l00109"></a>00109   <span class="comment">/* Reorder/renumber nodes and elements */</span>
<a name="l00110"></a>00110   ierr = <a class="code" href="init_8h.html#a37fbeb81912fa6f3e4bcc7e3dd71bc62">Reorder</a>(gdata);CHKERRQ(ierr);
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00113"></a>00113 <span class="preprocessor"></span>  <span class="comment">/* save coupling information after reordering */</span>
<a name="l00114"></a>00114   <span class="keywordflow">if</span> (gdata-&gt;vertcoupl!=PETSC_NULL) {
<a name="l00115"></a>00115     <span class="keywordtype">char</span> str[256];
<a name="l00116"></a>00116     ierr = PetscSNPrintf(str,255,<span class="stringliteral">&quot;%s.%04i.%s&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a2fba16fa768b0451df8fd12ed00a6c6b">simname</a>,gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>,<span class="stringliteral">&quot;vertcoupl&quot;</span>);CHKERRQ(ierr);
<a name="l00117"></a>00117     WriteVertcoupl(str,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,gdata-&gt;vertcoupl);
<a name="l00118"></a>00118   }
<a name="l00119"></a>00119 <span class="preprocessor">#endif</span>
<a name="l00120"></a>00120 <span class="preprocessor"></span>
<a name="l00121"></a>00121   <span class="comment">/* find faces, neighbours, surface */</span>
<a name="l00122"></a>00122   ierr = <a class="code" href="facnb_8c.html#ab880c52c1f93378088ef1e53763aa916">FacNB</a>(gdata);CHKERRQ(ierr);
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="comment">/* assign property ids to vertices */</span>
<a name="l00125"></a>00125   ierr = <a class="code" href="init_8h.html#a031e1284b34dfcb64f029f9bd16545ce">VertProp</a>(gdata);CHKERRQ(ierr);
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00128"></a>00128 <span class="preprocessor"></span>  ierr = DataPartitionSurfSer(gdata);CHKERRQ(ierr);
<a name="l00129"></a>00129   ierr = DataPartitionSurfSerMoveData(gdata);CHKERRQ(ierr);
<a name="l00130"></a>00130 <span class="preprocessor">#endif</span>
<a name="l00131"></a>00131 <span class="preprocessor"></span>
<a name="l00132"></a>00132   <span class="comment">/* distort surface and/or interior mesh (introduce roughness) */</span>
<a name="l00133"></a>00133   ierr = <a class="code" href="distortmesh_8c.html#a07f75fef1770fdca0f1cf8ea3369c8b2">DistortMesh</a>(gdata);CHKERRQ(ierr);
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="comment">/* distribute data to processors */</span>
<a name="l00136"></a>00136   ierr = <a class="code" href="init_8h.html#aac2a4c334ae5c2baef33867114fe8006">DataMoveData</a>(gdata);CHKERRQ(ierr);
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00139"></a>00139 }
<a name="l00140"></a>00140 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

